# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class AntivirusScanItem(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AntivirusScanItem - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'file': 'str',
            'force_run': 'bool',
            'policy': 'str',
            'report_id': 'str'
        }

        self.attribute_map = {
            'file': 'file',
            'force_run': 'force_run',
            'policy': 'policy',
            'report_id': 'report_id'
        }

        self._file = None
        self._force_run = None
        self._policy = None
        self._report_id = None

    @property
    def file(self):
        """
        Gets the file of this AntivirusScanItem.
        The full path of the file to scan.

        :return: The file of this AntivirusScanItem.
        :rtype: str
        """
        return self._file

    @file.setter
    def file(self, file):
        """
        Sets the file of this AntivirusScanItem.
        The full path of the file to scan.

        :param file: The file of this AntivirusScanItem.
        :type: str
        """
        
        if file is None:
            raise ValueError("Invalid value for `file`, must not be `None`")
        if len(file) < 1:
            raise ValueError("Invalid value for `file`, length must be greater than or equal to `1`")

        self._file = file

    @property
    def force_run(self):
        """
        Gets the force_run of this AntivirusScanItem.
        Forces the scan to run regardless of whether the files were recently scanned. The default value is true.

        :return: The force_run of this AntivirusScanItem.
        :rtype: bool
        """
        return self._force_run

    @force_run.setter
    def force_run(self, force_run):
        """
        Sets the force_run of this AntivirusScanItem.
        Forces the scan to run regardless of whether the files were recently scanned. The default value is true.

        :param force_run: The force_run of this AntivirusScanItem.
        :type: bool
        """
        
        self._force_run = force_run

    @property
    def policy(self):
        """
        Gets the policy of this AntivirusScanItem.
        The ID of the policy to use for the scan. By default, the scan will use the MANUAL policy.

        :return: The policy of this AntivirusScanItem.
        :rtype: str
        """
        return self._policy

    @policy.setter
    def policy(self, policy):
        """
        Sets the policy of this AntivirusScanItem.
        The ID of the policy to use for the scan. By default, the scan will use the MANUAL policy.

        :param policy: The policy of this AntivirusScanItem.
        :type: str
        """
        
        if policy is not None and len(policy) < 1:
            raise ValueError("Invalid value for `policy`, length must be greater than or equal to `1`")

        self._policy = policy

    @property
    def report_id(self):
        """
        Gets the report_id of this AntivirusScanItem.
        The ID for the report for this scan. A report ID will be generated if one is not provided.

        :return: The report_id of this AntivirusScanItem.
        :rtype: str
        """
        return self._report_id

    @report_id.setter
    def report_id(self, report_id):
        """
        Sets the report_id of this AntivirusScanItem.
        The ID for the report for this scan. A report ID will be generated if one is not provided.

        :param report_id: The report_id of this AntivirusScanItem.
        :type: str
        """
        
        if report_id is not None and len(report_id) < 1:
            raise ValueError("Invalid value for `report_id`, length must be greater than or equal to `1`")

        self._report_id = report_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

