# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class AuthAccessAccessItemFile(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AuthAccessAccessItemFile - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'group': 'str',
            'mode': 'str',
            'owner': 'str',
            'relevant_mode': 'str'
        }

        self.attribute_map = {
            'group': 'group',
            'mode': 'mode',
            'owner': 'owner',
            'relevant_mode': 'relevant_mode'
        }

        self._group = None
        self._mode = None
        self._owner = None
        self._relevant_mode = None

    @property
    def group(self):
        """
        Gets the group of this AuthAccessAccessItemFile.
        Specifies the group name or ID for the file.

        :return: The group of this AuthAccessAccessItemFile.
        :rtype: str
        """
        return self._group

    @group.setter
    def group(self, group):
        """
        Sets the group of this AuthAccessAccessItemFile.
        Specifies the group name or ID for the file.

        :param group: The group of this AuthAccessAccessItemFile.
        :type: str
        """
        
        self._group = group

    @property
    def mode(self):
        """
        Gets the mode of this AuthAccessAccessItemFile.
        Specifies the mode bits on the file.

        :return: The mode of this AuthAccessAccessItemFile.
        :rtype: str
        """
        return self._mode

    @mode.setter
    def mode(self, mode):
        """
        Sets the mode of this AuthAccessAccessItemFile.
        Specifies the mode bits on the file.

        :param mode: The mode of this AuthAccessAccessItemFile.
        :type: str
        """
        
        self._mode = mode

    @property
    def owner(self):
        """
        Gets the owner of this AuthAccessAccessItemFile.
        Specifies the name or ID of the file owner.

        :return: The owner of this AuthAccessAccessItemFile.
        :rtype: str
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """
        Sets the owner of this AuthAccessAccessItemFile.
        Specifies the name or ID of the file owner.

        :param owner: The owner of this AuthAccessAccessItemFile.
        :type: str
        """
        
        self._owner = owner

    @property
    def relevant_mode(self):
        """
        Gets the relevant_mode of this AuthAccessAccessItemFile.
        Specifies the mode bits that are related to the user.

        :return: The relevant_mode of this AuthAccessAccessItemFile.
        :rtype: str
        """
        return self._relevant_mode

    @relevant_mode.setter
    def relevant_mode(self, relevant_mode):
        """
        Sets the relevant_mode of this AuthAccessAccessItemFile.
        Specifies the mode bits that are related to the user.

        :param relevant_mode: The relevant_mode of this AuthAccessAccessItemFile.
        :type: str
        """
        
        self._relevant_mode = relevant_mode

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

