# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class FilepoolPolicy(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FilepoolPolicy - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'actions': 'list[FilepoolDefaultPolicyAction]',
            'apply_order': 'int',
            'description': 'str',
            'file_matching_pattern': 'FilepoolPolicyFileMatchingPattern',
            'name': 'str'
        }

        self.attribute_map = {
            'actions': 'actions',
            'apply_order': 'apply_order',
            'description': 'description',
            'file_matching_pattern': 'file_matching_pattern',
            'name': 'name'
        }

        self._actions = None
        self._apply_order = None
        self._description = None
        self._file_matching_pattern = None
        self._name = None

    @property
    def actions(self):
        """
        Gets the actions of this FilepoolPolicy.
        A list of actions to be taken for matching files

        :return: The actions of this FilepoolPolicy.
        :rtype: list[FilepoolDefaultPolicyAction]
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """
        Sets the actions of this FilepoolPolicy.
        A list of actions to be taken for matching files

        :param actions: The actions of this FilepoolPolicy.
        :type: list[FilepoolDefaultPolicyAction]
        """
        
        self._actions = actions

    @property
    def apply_order(self):
        """
        Gets the apply_order of this FilepoolPolicy.
        The order in which this policy should be applied (relative to other policies)

        :return: The apply_order of this FilepoolPolicy.
        :rtype: int
        """
        return self._apply_order

    @apply_order.setter
    def apply_order(self, apply_order):
        """
        Sets the apply_order of this FilepoolPolicy.
        The order in which this policy should be applied (relative to other policies)

        :param apply_order: The apply_order of this FilepoolPolicy.
        :type: int
        """
        
        self._apply_order = apply_order

    @property
    def description(self):
        """
        Gets the description of this FilepoolPolicy.
        A description for this policy

        :return: The description of this FilepoolPolicy.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this FilepoolPolicy.
        A description for this policy

        :param description: The description of this FilepoolPolicy.
        :type: str
        """
        
        self._description = description

    @property
    def file_matching_pattern(self):
        """
        Gets the file_matching_pattern of this FilepoolPolicy.
        The file matching rules for this policy

        :return: The file_matching_pattern of this FilepoolPolicy.
        :rtype: FilepoolPolicyFileMatchingPattern
        """
        return self._file_matching_pattern

    @file_matching_pattern.setter
    def file_matching_pattern(self, file_matching_pattern):
        """
        Sets the file_matching_pattern of this FilepoolPolicy.
        The file matching rules for this policy

        :param file_matching_pattern: The file_matching_pattern of this FilepoolPolicy.
        :type: FilepoolPolicyFileMatchingPattern
        """
        
        self._file_matching_pattern = file_matching_pattern

    @property
    def name(self):
        """
        Gets the name of this FilepoolPolicy.
        A unique name for this policy

        :return: The name of this FilepoolPolicy.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this FilepoolPolicy.
        A unique name for this policy

        :param name: The name of this FilepoolPolicy.
        :type: str
        """
        
        self._name = name

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

