# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class MappingUsersLookupMappingItem(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        MappingUsersLookupMappingItem - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'groups': 'list[MappingUsersLookupMappingItemGroup]',
            'privileges': 'list[AuthIdNtokenPrivilegeItem]',
            'user': 'MappingUsersLookupMappingItemUser',
            'zid': 'int',
            'zone': 'str'
        }

        self.attribute_map = {
            'groups': 'groups',
            'privileges': 'privileges',
            'user': 'user',
            'zid': 'zid',
            'zone': 'zone'
        }

        self._groups = None
        self._privileges = None
        self._user = None
        self._zid = None
        self._zone = None

    @property
    def groups(self):
        """
        Gets the groups of this MappingUsersLookupMappingItem.


        :return: The groups of this MappingUsersLookupMappingItem.
        :rtype: list[MappingUsersLookupMappingItemGroup]
        """
        return self._groups

    @groups.setter
    def groups(self, groups):
        """
        Sets the groups of this MappingUsersLookupMappingItem.


        :param groups: The groups of this MappingUsersLookupMappingItem.
        :type: list[MappingUsersLookupMappingItemGroup]
        """
        
        self._groups = groups

    @property
    def privileges(self):
        """
        Gets the privileges of this MappingUsersLookupMappingItem.


        :return: The privileges of this MappingUsersLookupMappingItem.
        :rtype: list[AuthIdNtokenPrivilegeItem]
        """
        return self._privileges

    @privileges.setter
    def privileges(self, privileges):
        """
        Sets the privileges of this MappingUsersLookupMappingItem.


        :param privileges: The privileges of this MappingUsersLookupMappingItem.
        :type: list[AuthIdNtokenPrivilegeItem]
        """
        
        self._privileges = privileges

    @property
    def user(self):
        """
        Gets the user of this MappingUsersLookupMappingItem.
        Specifies the configuration properties for a user.

        :return: The user of this MappingUsersLookupMappingItem.
        :rtype: MappingUsersLookupMappingItemUser
        """
        return self._user

    @user.setter
    def user(self, user):
        """
        Sets the user of this MappingUsersLookupMappingItem.
        Specifies the configuration properties for a user.

        :param user: The user of this MappingUsersLookupMappingItem.
        :type: MappingUsersLookupMappingItemUser
        """
        
        self._user = user

    @property
    def zid(self):
        """
        Gets the zid of this MappingUsersLookupMappingItem.


        :return: The zid of this MappingUsersLookupMappingItem.
        :rtype: int
        """
        return self._zid

    @zid.setter
    def zid(self, zid):
        """
        Sets the zid of this MappingUsersLookupMappingItem.


        :param zid: The zid of this MappingUsersLookupMappingItem.
        :type: int
        """
        
        self._zid = zid

    @property
    def zone(self):
        """
        Gets the zone of this MappingUsersLookupMappingItem.


        :return: The zone of this MappingUsersLookupMappingItem.
        :rtype: str
        """
        return self._zone

    @zone.setter
    def zone(self, zone):
        """
        Sets the zone of this MappingUsersLookupMappingItem.


        :param zone: The zone of this MappingUsersLookupMappingItem.
        :type: str
        """
        
        self._zone = zone

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

