# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class SettingsMappingExtendedExtended(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SettingsMappingExtendedExtended - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'domain': 'str',
            'mapping': 'str',
            'type': 'str'
        }

        self.attribute_map = {
            'domain': 'domain',
            'mapping': 'mapping',
            'type': 'type'
        }

        self._domain = None
        self._mapping = None
        self._type = None

    @property
    def domain(self):
        """
        Gets the domain of this SettingsMappingExtendedExtended.
        The FQDN of the source domain to map.

        :return: The domain of this SettingsMappingExtendedExtended.
        :rtype: str
        """
        return self._domain

    @domain.setter
    def domain(self, domain):
        """
        Sets the domain of this SettingsMappingExtendedExtended.
        The FQDN of the source domain to map.

        :param domain: The domain of this SettingsMappingExtendedExtended.
        :type: str
        """
        
        self._domain = domain

    @property
    def mapping(self):
        """
        Gets the mapping of this SettingsMappingExtendedExtended.
        The FQDN of destination domain to map to.

        :return: The mapping of this SettingsMappingExtendedExtended.
        :rtype: str
        """
        return self._mapping

    @mapping.setter
    def mapping(self, mapping):
        """
        Sets the mapping of this SettingsMappingExtendedExtended.
        The FQDN of destination domain to map to.

        :param mapping: The mapping of this SettingsMappingExtendedExtended.
        :type: str
        """
        
        self._mapping = mapping

    @property
    def type(self):
        """
        Gets the type of this SettingsMappingExtendedExtended.
        The authentication provider type.

        :return: The type of this SettingsMappingExtendedExtended.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this SettingsMappingExtendedExtended.
        The authentication provider type.

        :param type: The type of this SettingsMappingExtendedExtended.
        :type: str
        """
        allowed_values = ["ad", "local", "nis", "ldap"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )

        self._type = type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

